searchNodes=[{"doc":"Support for Automatic Persisted Queries in Absinthe. Query documents in GraphQL can be be of a significant size. Especially on mobile it may be beneficial to limit the size of the queries so fewer bytes go across the network. APQ uses a deterministic hash of the input query in a request. If the server does not know the hash the client can retry the request with the expanded query. The server can use this request to store the query in its cache. You'll need a GraphQL client that can use APQ, such as Apollo Client. Complete example project is available here Installation Since APQ is available in Hex , the package can be installed by adding apq to your list of dependencies in mix.exs : def deps do [ { :apq , &quot;~&gt; 2.0&quot; } ] end Examples Define a new module and use Apq.DocumentProvider : defmodule ApqExample.Apq do use Apq.DocumentProvider , cache_provider : ApqExample.Cache , max_query_size : 16384 #default end If you're going to use GET requests for APQ's hashed queries , you'll need to specify a json_codec that responds to decode!/1 such as Jason or Poison : defmodule ApqExample.Apq do use Apq.DocumentProvider , json_codec : Jason end In a Phoenix project, this should be set with Phoenix.json_library() . You'll need to implement a cache provider. This is up to you, the provider should implement Apq.CacheProvidr Cachex cache provider In this example I use Cachex . Define a module for the cache, e.g when using Cachex: defmodule ApqExample.Cachex.Cache do @behaviour Apq.CacheProvider def get ( hash ) do Cachex . get ( :apq_cache , hash ) end def put ( hash , query ) do Cachex . put ( :apq_cache , hash , query ) end end You'll need to start it in your supervision tree: children = [ worker ( Cachex , [ :apq_cache , [ limit : 100 ] ] ) , #... ] Redis cache provider Whe using Redis as a cache provider you can use the Redix library. You'll need to start a connection to Redis. children = [ { Redix , name : :redix } #... ] defmodule ApqExample.Redix do @behaviour Apq.CacheProvider def get ( hash ) do Redix . command ( :redix , [ &quot;GET&quot; , hash ] ) end def put ( hash , query ) do Redix . command ( :redix , [ &quot;SET&quot; , hash , query ] ) end end Now we need to add the ApqExample.Apq module to the list of document providers. This goes in your router file. match ( &quot;/api&quot; , to : Absinthe.Plug , init_opts : [ schema : ApqExample.Schema , json_codec : Jason , interface : :playground , document_providers : [ ApqExample.Apq , Absinthe.Plug.DocumentProvider.Default ] ] ) This is it, if you query with a client that has support for Apq it should work with Absinthe. Documentation Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/apq .","ref":"Apq.html","title":"Apq","type":"module"},{"doc":"Behaviour that the apq cache needs to conform to.","ref":"Apq.CacheProvider.html","title":"Apq.CacheProvider","type":"behaviour"},{"doc":"Get a query document given a hash from the cache","ref":"Apq.CacheProvider.html#c:get/1","title":"Apq.CacheProvider.get/1","type":"callback"},{"doc":"Put a query document in the cache with the hex-encoded sha256-hash as cache key","ref":"Apq.CacheProvider.html#c:put/2","title":"Apq.CacheProvider.put/2","type":"callback"},{"doc":"","ref":"Apq.CacheProvider.html#t:hash/0","title":"Apq.CacheProvider.hash/0","type":"type"},{"doc":"","ref":"Apq.CacheProvider.html#t:query_doc/0","title":"Apq.CacheProvider.query_doc/0","type":"type"},{"doc":"Apq document provider or Absinthe plug. Example Define a new module and use Apq.DocumentProvider : defmodule ApqExample.Apq do use Apq.DocumentProvider , cache_provider : ApqExample.Cache , max_query_size : 16384 # default end Options :cache_provider -- Module responsible for cache retrieval and placement. The cache provider needs to follow the Apq.CacheProvider behaviour. :max_query_size -- (Optional) Maximum number of bytes of the graphql query document. Defaults to 16384 bytes (16kb). :json_codec -- (Optional) Only required if using GET for APQ's hashed queries. Must respond to decode!/1 . :strategy -- Strategy whether to cache raw graphql strings, or the parsed/validated blueprint. Defaults to raw. Example configuration for using Apq in Absinthe.Plug . Same goes for configuring Phoenix. match ( &quot;/api&quot; , to : Absinthe.Plug , init_opts : [ schema : ApqExample.Schema , json_codec : Jason , interface : :playground , document_providers : [ ApqExample.Apq , Absinthe.Plug.DocumentProvider.Default ] ] ) When the Apq document provider does not match (i.e. the apq extensions are not set in the request), the request is passed to the next document provider. This will most likely by the default provider available ( Absinthe.Plug.DocumentProvider.Default ).","ref":"Apq.DocumentProvider.html","title":"Apq.DocumentProvider","type":"module"},{"doc":"Determine the remaining pipeline for a request with an apq document.","ref":"Apq.DocumentProvider.html#pipeline/2","title":"Apq.DocumentProvider.pipeline/2","type":"function"},{"doc":"Handles any requests with the Apq extensions and forwards those without to the next document provider.","ref":"Apq.DocumentProvider.html#process/2","title":"Apq.DocumentProvider.process/2","type":"function"},{"doc":"When document is found in the cache it will skip to the Context phase, passing by parsing/validation steps Otherwise it will just pass through the document. The ApqStoreDocument phase will pick it up for storing in the cache","ref":"Apq.Phase.ApqBlueprint.html","title":"Apq.Phase.ApqBlueprint","type":"module"},{"doc":"","ref":"Apq.Phase.ApqBlueprint.html#flag_invalid/1","title":"Apq.Phase.ApqBlueprint.flag_invalid/1","type":"function"},{"doc":"","ref":"Apq.Phase.ApqBlueprint.html#flag_invalid/2","title":"Apq.Phase.ApqBlueprint.flag_invalid/2","type":"function"},{"doc":"","ref":"Apq.Phase.ApqBlueprint.html#inherit_invalid/3","title":"Apq.Phase.ApqBlueprint.inherit_invalid/3","type":"function"},{"doc":"","ref":"Apq.Phase.ApqBlueprint.html#put_flag/2","title":"Apq.Phase.ApqBlueprint.put_flag/2","type":"function"},{"doc":"Behaviour to customize how Apq interacts with Absinthe pipeline","ref":"Apq.Strategy.html","title":"Apq.Strategy","type":"behaviour"},{"doc":"","ref":"Apq.Strategy.html#c:pipeline/2","title":"Apq.Strategy.pipeline/2","type":"callback"},{"doc":"Caching strategy that will cache the blueprint with validations having run.","ref":"Apq.Strategy.BlueprintDocument.html","title":"Apq.Strategy.BlueprintDocument","type":"module"},{"doc":"","ref":"Apq.Strategy.BlueprintDocument.html#do_pipeline/2","title":"Apq.Strategy.BlueprintDocument.do_pipeline/2","type":"function"},{"doc":"","ref":"Apq.Strategy.BlueprintDocument.html#pipeline/2","title":"Apq.Strategy.BlueprintDocument.pipeline/2","type":"function"},{"doc":"Caching strategy that will cache the raw string query","ref":"Apq.Strategy.RawDocument.html","title":"Apq.Strategy.RawDocument","type":"module"},{"doc":"","ref":"Apq.Strategy.RawDocument.html#do_pipeline/2","title":"Apq.Strategy.RawDocument.do_pipeline/2","type":"function"},{"doc":"Callback implementation for Apq.Strategy.pipeline/2 .","ref":"Apq.Strategy.RawDocument.html#pipeline/2","title":"Apq.Strategy.RawDocument.pipeline/2","type":"function"},{"doc":"] hex-page] [ [ Support for Automatic Persisted Queries in Absinthe. Query documents in GraphQL can be be of a significant size. Especially on mobile it may be beneficial to limit the size of the queries so fewer bytes go across the network. APQ uses a deterministic hash of the input query in a request. If the server does not know the hash the client can retry the request with the expanded query. The server can use this request to store the query in its cache. You'll need a GraphQL client that can use APQ, such as Apollo Client. Complete example project is available here","ref":"readme.html","title":"Apq","type":"extras"},{"doc":"Since APQ is available in Hex , the package can be installed by adding apq to your list of dependencies in mix.exs : def deps do [ { :apq , &quot;~&gt; 2.0&quot; } ] end","ref":"readme.html#installation","title":"Apq - Installation","type":"extras"},{"doc":"Define a new module and use Apq.DocumentProvider : defmodule ApqExample.Apq do use Apq.DocumentProvider , cache_provider : ApqExample.Cache , max_query_size : 16384 #default end If you're going to use GET requests for APQ's hashed queries , you'll need to specify a json_codec that responds to decode!/1 such as Jason or Poison : defmodule ApqExample.Apq do use Apq.DocumentProvider , json_codec : Jason end In a Phoenix project, this should be set with Phoenix.json_library() . You'll need to implement a cache provider. This is up to you, the provider should implement Apq.CacheProvidr Cachex cache provider In this example I use Cachex . Define a module for the cache, e.g when using Cachex: defmodule ApqExample.Cachex.Cache do @behaviour Apq.CacheProvider def get ( hash ) do Cachex . get ( :apq_cache , hash ) end def put ( hash , query ) do Cachex . put ( :apq_cache , hash , query ) end end You'll need to start it in your supervision tree: children = [ worker ( Cachex , [ :apq_cache , [ limit : 100 ] ] ) , #... ] Redis cache provider Whe using Redis as a cache provider you can use the Redix library. You'll need to start a connection to Redis. children = [ { Redix , name : :redix } #... ] defmodule ApqExample.Redix do @behaviour Apq.CacheProvider def get ( hash ) do Redix . command ( :redix , [ &quot;GET&quot; , hash ] ) end def put ( hash , query ) do Redix . command ( :redix , [ &quot;SET&quot; , hash , query ] ) end end Now we need to add the ApqExample.Apq module to the list of document providers. This goes in your router file. match ( &quot;/api&quot; , to : Absinthe.Plug , init_opts : [ schema : ApqExample.Schema , json_codec : Jason , interface : :playground , document_providers : [ ApqExample.Apq , Absinthe.Plug.DocumentProvider.Default ] ] ) This is it, if you query with a client that has support for Apq it should work with Absinthe.","ref":"readme.html#examples","title":"Apq - Examples","type":"extras"},{"doc":"Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/apq .","ref":"readme.html#documentation","title":"Apq - Documentation","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Add support for GET queries CI: Travis -&gt; Github actions","ref":"changelog.html#1-2","title":"Changelog - 1.2","type":"extras"}]